<?php
// $Id: regcode.rules.inc,v 1.1.2.1 2009/07/22 21:40:21 aidan Exp $

/**
 * Implementation of hook_rules_event_info()
 */
function regcode_rules_event_info() {
  return array(
    'regcode_used' => array(
      'label' => t('User has used a registration code'),
      'module' => 'Regcode',
      'arguments' => array(
        'user'    => array('type' => 'user',    'label' => t('The user using the code')),
        'regcode' => array('type' => 'regcode', 'label' => t('The regcode which was used')),
      ),
    ),
  );
}

/**
* Implementation of hook_rules_data_type_info()
*/
function regcode_rules_data_type_info() {
  return array(
    'node' => array(
      'label' => t('Regcode'),
      'class' => 'rules_data_type_regcode',
      'savable' => FALSE,
      'identifiable' => TRUE,
      'uses_input_form' => FALSE,
      'module' => 'regcode',
    ),
  );
}

/**
 * Defines the rules regcode data type
 */
class rules_data_type_regcode extends rules_data_type {

  function load($rid) {
    return db_fetch_object(db_query('SELECT * FROM {regcode} WHERE rid=%d', $rid));
  }

  function get_identifier() {
    $regcode = &$this->get();
    return $regcode->rid;
  }
}